"""
ArchiveDateGrep v1.1
Checks for files modifies after a given date time and then adds them to a archive 
file that can be easily extracted -

Philip Roche http://philroche.net/downloads
"""

import os, time, sys
import zipfile
from xml.dom import minidom 
from datetime import datetime
from subprocess import *


class SVNArchiveByChangeSet:
    today = time.time()
    todaynow = datetime.now() 
    sChangeset = ""
    iChangeSet = 0
    zFileName = ""
    sFilesChanged = ""
    
    def __init__(self):
        self.GetArgs()
        self.runSVNOutPut()        
        self.ArchiveFiles()
        print "Finished"  
        
    def GetArgs(self):
        if len(sys.argv) == 1:
            self.sChangeset=str(raw_input("Changeset : "))
            self.sChangeset = self.sChangeset.strip().lower()
            if self.sChangeset != "":
                try:
                    self.iChangeSet = int(self.sChangeset)
                except:
                    print "This is not a valid changeset"
                    #exception in casting to int           
        else:
            try:                
                self.iChangeSet = int(sys.argv[1])                       
            except:
                print "This is not a valid changeset"
                #exception in casting to int 
          

    def ArchiveFiles(self):
        strFilesChanged = self.sFilesChanged
     
        
        strTimeStamp = "-"+str(self.todaynow.hour)+"-"+str(self.todaynow.minute)+"-"+str(self.todaynow.day)+"-"+str(self.todaynow.month)+"-"+str(self.todaynow.year)
        
        doc = minidom.parseString(strFilesChanged)
        fileList = []
        all_paths = doc.documentElement.getElementsByTagName('path')
        for x in all_paths:
            fileList.append(str(x.firstChild.nodeValue))
            #print dir(x)
            print x.firstChild.nodeValue
        
            
              
        self.zFileName = "Changset"+str(self.iChangeSet)+strTimeStamp+".zip"
        zFile = zipfile.ZipFile(self.zFileName, "w")
                
        #get a list of all the root level directories
        curDir = os.getcwd()
      
        for name in fileList: 
            #add the file to the archive 
            curPath = os.path.abspath(curDir+name)   
            curPath = curPath.replace(".\\","")                       
            if curPath.find('.')==0:
                curPath = curPath[1:]                    
            print curPath           
            zFile.write(curPath, name[1:], zipfile.ZIP_DEFLATED)
            
        zFile.close()
        
      
    
    def runSVNOutPut(self):  
        '''
        svn log -v -r136
        '''      
        try:
            p = Popen("svn log -v --xml -r"+str(self.iChangeSet),stdout=PIPE) 
            self.sFilesChanged = p.stdout.read()
               
        except OSError, e:
            print "runSVNOutPut Execution failed:" + str(e)
        return
        
if __name__ == '__main__':
    SVNArchiveByChangeSet = SVNArchiveByChangeSet()
    
